#ifndef __CTimer_H__
#define __CTimer_H__ 1

#include <sys/time.h>

class CTimer
{
	public:
		CTimer();
		void          start();
		void          stop();
		void          reset();
		bool          isRunning();
		unsigned long getTime();
		bool          isOver(unsigned long seconds);
	private:
		bool          m_resetted;
		bool          m_running;
		unsigned long m_begin;
		unsigned long m_end;
};

CTimer::CTimer()
{
	m_resetted = true;
	m_running = false;
	m_begin = 0;
	m_end = 0;
}

void CTimer::start()
{
	if(!m_running) {
		if(m_resetted)
			m_begin = (unsigned long) clock();
		else
			m_begin -= m_end - (unsigned long) clock();
		m_running = true;
		m_resetted = false;
	}
}

void CTimer::stop()
{
	if(m_running) {
		m_end = (unsigned long) clock();
		m_running = false;
	}
}

void CTimer::reset()
{
	bool wereRunning = m_running;
	if(wereRunning)
		stop();
	m_resetted = true;
	m_begin = 0;
	m_end = 0;
	if(wereRunning)
		start();
}

bool CTimer::isRunning()
{
	return m_running;
}

unsigned long CTimer::getTime()
{
	if(m_running)
		return ((unsigned long) clock() - m_begin) / CLOCKS_PER_SEC;
	else
		return m_end - m_begin / CLOCKS_PER_SEC;
}

bool CTimer::isOver(unsigned long seconds)
{
	return seconds <= getTime();
}

#endif
/* vim:set tabstop=8 softtabstop=8 shiftwidth=8 noexpandtab: */
